
#include <reg52.h>				//MCUͷļ
#include <intrins.h>				//nopָͷļ

#define nop _nop_();_nop_();_nop_();_nop_();_nop_();_nop_(); //궨



/********************ƶ˿**********************/
sbit DIO=P1^0;						//DIO
sbit CLK=P1^1;						//CLK
sbit STB=P1^2;						//STB


/***********************

***********************/
unsigned char Key[5]={0};		   //Ϊ洢ֵ
const unsigned char BCD_LABLE_ALL[]=
	{0xbf,0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x6f,0x00,0x01,0x03,0x07,0x0f,0x1f,0x3f,0x7f,0xff};
	
unsigned char BCD_LABLE_anode[16] = {0}; //ڱ湲ʾ  TM1628ʾĴе еֵ

unsigned char cmd_dis_mode = 0x8f;   
/***************ʱ**************/
void delay_nms(unsigned int n)
{
  unsigned int i;
  while(n--) 
    for(i=0;i<550;i++);
}
void delay_nus(unsigned int n)
{
  unsigned int i;
  while(n--) 
    for(i=0;i<50;i++);
}

/***************8bitݣӵλʼ**************/
void send_8bit(unsigned char dat)	
{
  unsigned char i;
  for(i=0;i<8;i++)
  {	 
    CLK=0;
    if(dat&0x01) 
	  DIO=1;
	else 
	  DIO=0;
	 _nop_();
	 _nop_();
	 _nop_();
	
	 CLK=1;
	 dat>>=1;
	 
  }
    CLK=0;
	DIO=0;
}

/******************Ϳ***********************/
void send_command(unsigned char word)
{
 STB=1;
 _nop_();
   
 STB=0;
 send_8bit(word);
 
}

void Write_String(unsigned char *p,unsigned char cnt) //cnt14byte
{ 
 unsigned char i; 
 
 for(i=0;i<cnt;i++) 	//д 
 { 
	send_8bit(*p++);
 }  
}


/***************************************************
8ʾĹݵݵת λ   
--  ʵһת ֻıλ
****************************************************/
void NE_C(unsigned char ydata,unsigned char cnt)  
{
	char i=0,j=0;
	if(cnt>0)
	{
	   if(cnt>8)
	   {
	   	  //myflag |= 0x01;
			   cnt = cnt -9;
				 for(i=1;i<16;i=i+2)
				{
					
					if(ydata&0x01 == 0x01)
					{
						BCD_LABLE_anode[i] |=  (0x01<<cnt);		
					}
					else
					{
						BCD_LABLE_anode[i] &= ~(0x01<<cnt);	//
					}
					ydata = (ydata>>1);
				}  
			   
	   }
	   else
	   {
	   	 cnt = cnt -1;
		 	for(i=0;i<16;i=i+2)
			{
			
				if((ydata&0x01) == 0x01)
				{
					BCD_LABLE_anode[i] |=  (0x01<<cnt);		
				}
				else
				{
				    BCD_LABLE_anode[i] &= ~(0x01<<cnt);//
				}
				ydata = (ydata>>1);
			 }  
	   }	
	}	


	
}

/************************************************************************************
SEG1-SEG8 ֱʾ1-8λܣ£
cnt1 :ʾcnt1;
number: ʾҪʾݣnumber=1 ʾ1;
display(0,1): ʾڵ1λʾ0.
BCD_LABLE_ALL[0]:ʾ0x3f, 0,ͻԸҪԼݼ
************************************************************************************/
void display(unsigned char number,unsigned char cnt1)
{
   		 
		 NE_C(BCD_LABLE_ALL[number],cnt1);   				//ݱ任
		 send_command(0x40);												//:ͨģʽַ1дݵԴ
		 send_command(0xc0);												//ʾַ00Hʼ
		 Write_String(BCD_LABLE_anode,16);					//д 16ֽ Ϊ1629ϵܹ16Դ  
		 STB=1;
 		 send_command(cmd_dis_mode);
}	

									 
void display_fixedadd(unsigned char number,unsigned char cnt1)
{
   		 
		 NE_C(BCD_LABLE_ALL[number],cnt1);
		 send_command(0x44);	//:ͨģʽ̶ַģʽдݵԴ
 		 send_command(0xc2);
		 send_8bit(0x00);//02ַд00
		 STB=0;
		 send_command(cmd_dis_mode);
		 STB=0;

}										 


/****************ȡֵ洢*******************/
void read_key()
{
	unsigned char i,j;
	send_command(0x42);
	DIO=1;					//ͷDIO
	for(j=0;j<4;j++)
	{
		for(i=0;i<8;i++)
		{
			CLK=0;
			Key[j]=Key[j]>>1;
			CLK=1;
			if(DIO)
				Key[j]=Key[j]|0x80;
				nop;
		}
		nop;
		nop;
	}
	CLK=0;
	DIO=0;

	STB=1;
}

void key_process()		
{  
   if(Key[0]!=0x00)
   { 
    if((Key[0]==0x08)){display(1,1);} //K0SEG1£ʾ1
    if((Key[0]==0x04)){display(2,1);} //K1SEG1£ʾ2
   }
    if(Key[1]!=0x00)
   { 
    if((Key[1]==0x08)){display(3,1);} //K0SEG3£ʾ3
    if((Key[1]==0x04)){display(4,1);} //K1SEG3£ʾ4
   } 
}


void main()
{


//	//ӵһڰ˸һ ʾ 1 2 3 4 5 6 7 8  
	for(i=1;i<=8;i++)
	{	
		display(i%10,i);   
	} 	
	//
	while(1);
	{		
			read_key();
			key_process();
			delay_nms(5);	
	}
}


